/* FastListModel.c generated by valac 0.48.17, the Vala compiler
 * generated from FastListModel.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */
/* Since this class is not publicly facing (the FastView is public part),
 * this model is low level and optimized. We are not worried about stupid
 * users here.
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gee.h>
#include "io.elementary.music-core.h"
#include <string.h>

#define MUSIC_TYPE_FAST_MODEL (music_fast_model_get_type ())
#define MUSIC_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_TYPE_FAST_MODEL, MusicFastModel))
#define MUSIC_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_TYPE_FAST_MODEL, MusicFastModelClass))
#define MUSIC_IS_FAST_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_TYPE_FAST_MODEL))
#define MUSIC_IS_FAST_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_TYPE_FAST_MODEL))
#define MUSIC_FAST_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_TYPE_FAST_MODEL, MusicFastModelClass))

typedef struct _MusicFastModel MusicFastModel;
typedef struct _MusicFastModelClass MusicFastModelClass;
typedef struct _MusicFastModelPrivate MusicFastModelPrivate;
typedef GValue* (*MusicFastModelValueReturnFunc) (gint row, gint column, GObject* o, gpointer user_data);
enum  {
	MUSIC_FAST_MODEL_0_PROPERTY,
	MUSIC_FAST_MODEL_COLUMNS_PROPERTY,
	MUSIC_FAST_MODEL_NUM_PROPERTIES
};
static GParamSpec* music_fast_model_properties[MUSIC_FAST_MODEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
enum  {
	MUSIC_FAST_MODEL_REORDER_REQUESTED_SIGNAL,
	MUSIC_FAST_MODEL_NUM_SIGNALS
};
static guint music_fast_model_signals[MUSIC_FAST_MODEL_NUM_SIGNALS] = {0};

struct _MusicFastModel {
	GObject parent_instance;
	MusicFastModelPrivate * priv;
};

struct _MusicFastModelClass {
	GObjectClass parent_class;
};

struct _MusicFastModelPrivate {
	gint stamp;
	GeeArrayList* rows;
	GeeList* _columns;
	gint sort_column_id;
	GtkSortType sort_direction;
	MusicFastModelValueReturnFunc value_func;
	gpointer value_func_target;
};

static gint MusicFastModel_private_offset;
static gpointer music_fast_model_parent_class = NULL;
static GtkTreeModelIface * music_fast_model_gtk_tree_model_parent_iface = NULL;
static GtkTreeSortableIface * music_fast_model_gtk_tree_sortable_parent_iface = NULL;

GType music_fast_model_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicFastModel, g_object_unref)
MusicFastModel* music_fast_model_new (GeeList* column_types);
MusicFastModel* music_fast_model_construct (GType object_type,
                                            GeeList* column_types);
static GType music_fast_model_real_get_column_type (GtkTreeModel* base,
                                             gint col);
GeeList* music_fast_model_get_columns (MusicFastModel* self);
static GtkTreeModelFlags music_fast_model_real_get_flags (GtkTreeModel* base);
static gboolean music_fast_model_real_get_iter (GtkTreeModel* base,
                                         GtkTreeIter* iter,
                                         GtkTreePath* path);
static gint music_fast_model_real_get_n_columns (GtkTreeModel* base);
static GtkTreePath* music_fast_model_real_get_path (GtkTreeModel* base,
                                             GtkTreeIter* iter);
static void music_fast_model_real_get_value (GtkTreeModel* base,
                                      GtkTreeIter* iter,
                                      gint column,
                                      GValue* val);
static void _vala_GValue_free (GValue* self);
GObject* music_fast_model_get_object (MusicFastModel* self,
                                      GtkTreeIter* iter);
static gboolean music_fast_model_real_iter_children (GtkTreeModel* base,
                                              GtkTreeIter* iter,
                                              GtkTreeIter* parent);
static gboolean music_fast_model_real_iter_has_child (GtkTreeModel* base,
                                               GtkTreeIter* iter);
static gint music_fast_model_real_iter_n_children (GtkTreeModel* base,
                                            GtkTreeIter* iter);
static gboolean music_fast_model_real_iter_next (GtkTreeModel* base,
                                          GtkTreeIter* iter);
static gboolean music_fast_model_real_iter_nth_child (GtkTreeModel* base,
                                               GtkTreeIter* iter,
                                               GtkTreeIter* parent,
                                               gint n);
static gboolean music_fast_model_real_iter_parent (GtkTreeModel* base,
                                            GtkTreeIter* iter,
                                            GtkTreeIter* child);
void music_fast_model_append (MusicFastModel* self,
                              GtkTreeIter* iter);
static void _vala_GtkTreePath_free (GtkTreePath* self);
void music_fast_model_remove (MusicFastModel* self,
                              GtkTreeIter* iter);
void music_fast_model_set (MusicFastModel* self,
                           GtkTreeIter* iter,
                           ...);
static void music_fast_model_real_ref_node (GtkTreeModel* base,
                                     GtkTreeIter* iter);
static void music_fast_model_real_unref_node (GtkTreeModel* base,
                                       GtkTreeIter* iter);
void music_fast_model_set_table (MusicFastModel* self,
                                 GeeArrayList* table);
void music_fast_model_set_value_func (MusicFastModel* self,
                                      MusicFastModelValueReturnFunc func,
                                      gpointer func_target);
void music_fast_model_update_row (MusicFastModel* self,
                                  gint index);
static gboolean music_fast_model_real_get_sort_column_id (GtkTreeSortable* base,
                                                   gint* column_id,
                                                   GtkSortType* order);
static void music_fast_model_real_set_sort_column_id (GtkTreeSortable* base,
                                               gint column,
                                               GtkSortType order);
static gboolean music_fast_model_real_has_default_sort_func (GtkTreeSortable* base);
static void music_fast_model_real_set_sort_func (GtkTreeSortable* base,
                                          gint sort_column_id,
                                          GtkTreeIterCompareFunc sort_func,
                                          gpointer sort_func_target,
                                          GDestroyNotify sort_func_target_destroy_notify);
static void music_fast_model_real_set_default_sort_func (GtkTreeSortable* base,
                                                  GtkTreeIterCompareFunc sort_func,
                                                  gpointer sort_func_target,
                                                  GDestroyNotify sort_func_target_destroy_notify);
void music_fast_model_set_columns (MusicFastModel* self,
                                   GeeList* value);
static void g_cclosure_user_marshal_VOID__INT_ENUM (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data);
static GObject * music_fast_model_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static void music_fast_model_finalize (GObject * obj);
static GType music_fast_model_get_type_once (void);
static void _vala_music_fast_model_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_music_fast_model_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
music_fast_model_get_instance_private (MusicFastModel* self)
{
	return G_STRUCT_MEMBER_P (self, MusicFastModel_private_offset);
}

/** Initialize data storage, columns, etc. **/
MusicFastModel*
music_fast_model_construct (GType object_type,
                            GeeList* column_types)
{
	MusicFastModel * self = NULL;
	g_return_val_if_fail (column_types != NULL, NULL);
	self = (MusicFastModel*) g_object_new (object_type, "columns", column_types, NULL);
	return self;
}

MusicFastModel*
music_fast_model_new (GeeList* column_types)
{
	return music_fast_model_construct (MUSIC_TYPE_FAST_MODEL, column_types);
}

static GType
music_fast_model_real_get_column_type (GtkTreeModel* base,
                                       gint col)
{
	MusicFastModel * self;
	GeeList* _tmp0_;
	gpointer _tmp1_;
	GType result = 0UL;
	self = (MusicFastModel*) base;
	_tmp0_ = self->priv->_columns;
	_tmp1_ = gee_list_get (_tmp0_, col);
	result = (GType) ((gintptr) _tmp1_);
	return result;
}

static GtkTreeModelFlags
music_fast_model_real_get_flags (GtkTreeModel* base)
{
	MusicFastModel * self;
	GtkTreeModelFlags result = 0U;
	self = (MusicFastModel*) base;
	result = GTK_TREE_MODEL_LIST_ONLY;
	return result;
}

static gboolean
music_fast_model_real_get_iter (GtkTreeModel* base,
                                GtkTreeIter* iter,
                                GtkTreePath* path)
{
	MusicFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gint path_index = 0;
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint _tmp2_;
	guint size = 0U;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean result = FALSE;
	self = (MusicFastModel*) base;
	g_return_val_if_fail (path != NULL, FALSE);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	_tmp1_ = gtk_tree_path_get_indices_with_depth (path, &_tmp0_);
	_tmp2_ = _tmp1_[0];
	path_index = _tmp2_;
	_tmp3_ = self->priv->rows;
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	size = (guint) _tmp5_;
	if (size == ((guint) 0)) {
		_tmp8_ = TRUE;
	} else {
		_tmp8_ = path_index < 0;
	}
	if (_tmp8_) {
		_tmp7_ = TRUE;
	} else {
		_tmp7_ = ((guint) path_index) >= size;
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		GeeArrayList* _tmp9_;
		gpointer _tmp10_;
		GObject* _tmp11_;
		_tmp9_ = self->priv->rows;
		_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, path_index);
		_tmp11_ = (GObject*) _tmp10_;
		_tmp6_ = _tmp11_ == NULL;
		_g_object_unref0 (_tmp11_);
	}
	if (_tmp6_) {
		result = FALSE;
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	_vala_iter.stamp = self->priv->stamp;
	_vala_iter.user_data = (void*) path_index;
	result = TRUE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

static gint
music_fast_model_real_get_n_columns (GtkTreeModel* base)
{
	MusicFastModel * self;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result = 0;
	self = (MusicFastModel*) base;
	_tmp0_ = self->priv->_columns;
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

static GtkTreePath*
music_fast_model_real_get_path (GtkTreeModel* base,
                                GtkTreeIter* iter)
{
	MusicFastModel * self;
	GtkTreeIter _tmp0_;
	void* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkTreePath* _tmp4_;
	GtkTreePath* _tmp5_;
	GtkTreePath* result = NULL;
	self = (MusicFastModel*) base;
	g_return_val_if_fail (iter != NULL, NULL);
	_tmp0_ = *iter;
	_tmp1_ = _tmp0_.user_data;
	_tmp2_ = g_strdup_printf ("%i", (gint) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gtk_tree_path_new_from_string (_tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	result = _tmp5_;
	return result;
}

static void
_vala_GValue_free (GValue* self)
{
	g_boxed_free (G_TYPE_VALUE, self);
}

static void
music_fast_model_real_get_value (GtkTreeModel* base,
                                 GtkTreeIter* iter,
                                 gint column,
                                 GValue* val)
{
	MusicFastModel * self;
	GValue _vala_val = {0};
	GValue _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GtkTreeIter _tmp3_;
	GValue _tmp4_ = {0};
	gint row = 0;
	GtkTreeIter _tmp5_;
	void* _tmp6_;
	GObject* object = NULL;
	GeeArrayList* _tmp7_;
	gpointer _tmp8_;
	GObject* _tmp9_;
	self = (MusicFastModel*) base;
	g_return_if_fail (iter != NULL);
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	_vala_val = _tmp0_;
	_tmp3_ = *iter;
	if (_tmp3_.stamp != self->priv->stamp) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = column < 0;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = column >= gtk_tree_model_get_n_columns ((GtkTreeModel*) self);
	}
	if (_tmp1_) {
		if (val) {
			*val = _vala_val;
		} else {
			G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		}
		return;
	}
	g_value_init (&_tmp4_, gtk_tree_model_get_column_type ((GtkTreeModel*) self, column));
	G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	_vala_val = _tmp4_;
	_tmp5_ = *iter;
	_tmp6_ = _tmp5_.user_data;
	row = (gint) _tmp6_;
	_tmp7_ = self->priv->rows;
	_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, row);
	object = (GObject*) _tmp8_;
	_tmp9_ = object;
	if (_tmp9_ != NULL) {
		MusicFastModelValueReturnFunc _tmp10_;
		gpointer _tmp10__target;
		GObject* _tmp11_;
		GValue* _tmp12_;
		GValue* _tmp13_;
		GValue _tmp14_;
		GValue _tmp15_ = {0};
		_tmp10_ = self->priv->value_func;
		_tmp10__target = self->priv->value_func_target;
		_tmp11_ = object;
		_tmp12_ = _tmp10_ (row, column, _tmp11_, _tmp10__target);
		_tmp13_ = _tmp12_;
		_tmp14_ = *_tmp13_;
		if (G_IS_VALUE (&_tmp14_)) {
			g_value_init (&_tmp15_, G_VALUE_TYPE (&_tmp14_));
			g_value_copy (&_tmp14_, &_tmp15_);
		} else {
			_tmp15_ = _tmp14_;
		}
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		_vala_val = _tmp15_;
		__vala_GValue_free0 (_tmp13_);
	}
	_g_object_unref0 (object);
	if (val) {
		*val = _vala_val;
	} else {
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	}
}

GObject*
music_fast_model_get_object (MusicFastModel* self,
                             GtkTreeIter* iter)
{
	GeeArrayList* _tmp0_;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	gpointer _tmp3_;
	GObject* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (iter != NULL, NULL);
	_tmp0_ = self->priv->rows;
	_tmp1_ = *iter;
	_tmp2_ = _tmp1_.user_data;
	_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, (gint) _tmp2_);
	result = (GObject*) _tmp3_;
	return result;
}

static gboolean
music_fast_model_real_iter_children (GtkTreeModel* base,
                                     GtkTreeIter* iter,
                                     GtkTreeIter* parent)
{
	MusicFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	self = (MusicFastModel*) base;
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	result = FALSE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

static gboolean
music_fast_model_real_iter_has_child (GtkTreeModel* base,
                                      GtkTreeIter* iter)
{
	MusicFastModel * self;
	gboolean result = FALSE;
	self = (MusicFastModel*) base;
	g_return_val_if_fail (iter != NULL, FALSE);
	result = FALSE;
	return result;
}

static gint
music_fast_model_real_iter_n_children (GtkTreeModel* base,
                                       GtkTreeIter* iter)
{
	MusicFastModel * self;
	gint _tmp0_ = 0;
	gint result = 0;
	self = (MusicFastModel*) base;
	if (iter == NULL) {
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		_tmp1_ = self->priv->rows;
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_tmp0_ = (gint) _tmp3_;
	} else {
		_tmp0_ = 0;
	}
	result = _tmp0_;
	return result;
}

static gboolean
music_fast_model_real_iter_next (GtkTreeModel* base,
                                 GtkTreeIter* iter)
{
	MusicFastModel * self;
	GtkTreeIter _tmp0_;
	gint index = 0;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	gint _tmp3_;
	GeeArrayList* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean result = FALSE;
	self = (MusicFastModel*) base;
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = *iter;
	if (_tmp0_.stamp != self->priv->stamp) {
		result = FALSE;
		return result;
	}
	_tmp1_ = *iter;
	_tmp2_ = _tmp1_.user_data;
	index = (gint) _tmp2_;
	index = index + 1;
	_tmp3_ = index;
	(*iter).user_data = (void*) _tmp3_;
	_tmp4_ = self->priv->rows;
	_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
	_tmp6_ = _tmp5_;
	result = index < _tmp6_;
	return result;
}

static gboolean
music_fast_model_real_iter_nth_child (GtkTreeModel* base,
                                      GtkTreeIter* iter,
                                      GtkTreeIter* parent,
                                      gint n)
{
	MusicFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result = FALSE;
	self = (MusicFastModel*) base;
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	if (n < 0) {
		_tmp1_ = TRUE;
	} else {
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		_tmp2_ = self->priv->rows;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp1_ = n >= _tmp4_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = parent != NULL;
	}
	if (_tmp0_) {
		result = FALSE;
		if (iter) {
			*iter = _vala_iter;
		}
		return result;
	}
	_vala_iter.stamp = self->priv->stamp;
	_vala_iter.user_data = (void*) n;
	result = TRUE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

static gboolean
music_fast_model_real_iter_parent (GtkTreeModel* base,
                                   GtkTreeIter* iter,
                                   GtkTreeIter* child)
{
	MusicFastModel * self;
	GtkTreeIter _vala_iter = {0};
	gboolean result = FALSE;
	self = (MusicFastModel*) base;
	g_return_val_if_fail (child != NULL, FALSE);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	result = FALSE;
	if (iter) {
		*iter = _vala_iter;
	}
	return result;
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

void
music_fast_model_append (MusicFastModel* self,
                         GtkTreeIter* iter)
{
	GtkTreeIter _vala_iter = {0};
	gint index = 0;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp3_;
	GeeArrayList* _tmp4_;
	GObject* _tmp5_;
	GObject* _tmp6_;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GtkTreeIter _tmp10_;
	g_return_if_fail (self != NULL);
	memset (&_vala_iter, 0, sizeof (GtkTreeIter));
	_tmp0_ = self->priv->rows;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	index = (gint) _tmp2_;
	_tmp3_ = gtk_tree_path_new_from_indices (index, -1, -1);
	path = _tmp3_;
	_tmp4_ = self->priv->rows;
	_tmp5_ = g_object_new (G_TYPE_OBJECT, NULL);
	_tmp6_ = _tmp5_;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp6_);
	_g_object_unref0 (_tmp6_);
	_vala_iter.stamp = self->priv->stamp;
	_tmp7_ = self->priv->rows;
	_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
	_tmp9_ = _tmp8_;
	_vala_iter.user_data = (void*) _tmp9_;
	_tmp10_ = _vala_iter;
	gtk_tree_model_row_inserted ((GtkTreeModel*) self, path, &_tmp10_);
	__vala_GtkTreePath_free0 (path);
	if (iter) {
		*iter = _vala_iter;
	}
}

void
music_fast_model_remove (MusicFastModel* self,
                         GtkTreeIter* iter)
{
	GtkTreeIter _tmp0_;
	gint index = 0;
	GtkTreeIter _tmp1_;
	void* _tmp2_;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp3_;
	GeeArrayList* _tmp4_;
	gpointer _tmp5_;
	GObject* _tmp6_;
	GtkTreePath* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (iter != NULL);
	_tmp0_ = *iter;
	if (_tmp0_.stamp != self->priv->stamp) {
		return;
	}
	_tmp1_ = *iter;
	_tmp2_ = _tmp1_.user_data;
	index = (gint) _tmp2_;
	_tmp3_ = gtk_tree_path_new_from_indices (index, -1, -1);
	path = _tmp3_;
	_tmp4_ = self->priv->rows;
	_tmp5_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp4_, index);
	_tmp6_ = (GObject*) _tmp5_;
	_g_object_unref0 (_tmp6_);
	_tmp7_ = path;
	gtk_tree_model_row_deleted ((GtkTreeModel*) self, _tmp7_);
	__vala_GtkTreePath_free0 (path);
}

void
music_fast_model_set (MusicFastModel* self,
                      GtkTreeIter* iter,
                      ...)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (iter != NULL);
	return;
}

static void
music_fast_model_real_ref_node (GtkTreeModel* base,
                                GtkTreeIter* iter)
{
	MusicFastModel * self;
	self = (MusicFastModel*) base;
	g_return_if_fail (iter != NULL);
}

static void
music_fast_model_real_unref_node (GtkTreeModel* base,
                                  GtkTreeIter* iter)
{
	MusicFastModel * self;
	self = (MusicFastModel*) base;
	g_return_if_fail (iter != NULL);
}

void
music_fast_model_set_table (MusicFastModel* self,
                            GeeArrayList* table)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GtkTreeIter iter = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (table != NULL);
	_tmp0_ = self->priv->rows;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	_tmp1_ = self->priv->rows;
	gee_array_list_add_all (_tmp1_, (GeeCollection*) table);
	{
		gboolean valid = FALSE;
		GtkTreeIter _tmp2_ = {0};
		gboolean _tmp3_;
		_tmp3_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) self, &_tmp2_);
		iter = _tmp2_;
		valid = _tmp3_;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				GtkTreeIter _tmp6_;
				GtkTreePath* _tmp7_;
				GtkTreePath* _tmp8_;
				GtkTreeIter _tmp9_;
				if (!_tmp4_) {
					gboolean _tmp5_;
					_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) self, &iter);
					valid = _tmp5_;
				}
				_tmp4_ = FALSE;
				if (!valid) {
					break;
				}
				_tmp6_ = iter;
				_tmp7_ = gtk_tree_model_get_path ((GtkTreeModel*) self, &_tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = iter;
				gtk_tree_model_row_changed ((GtkTreeModel*) self, _tmp8_, &_tmp9_);
				__vala_GtkTreePath_free0 (_tmp8_);
			}
		}
	}
}

void
music_fast_model_set_value_func (MusicFastModel* self,
                                 MusicFastModelValueReturnFunc func,
                                 gpointer func_target)
{
	g_return_if_fail (self != NULL);
	self->priv->value_func = func;
	self->priv->value_func_target = func_target;
}

void
music_fast_model_update_row (MusicFastModel* self,
                             gint index)
{
	GtkTreePath* path = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreePath* _tmp3_;
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup_printf ("%i", index);
	_tmp1_ = _tmp0_;
	_tmp2_ = gtk_tree_path_new_from_string (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	path = _tmp3_;
	memset (&iter, 0, sizeof (GtkTreeIter));
	iter.stamp = self->priv->stamp;
	iter.user_data = (void*) index;
	_tmp4_ = iter;
	gtk_tree_model_row_changed ((GtkTreeModel*) self, path, &_tmp4_);
	__vala_GtkTreePath_free0 (path);
}

static gboolean
music_fast_model_real_get_sort_column_id (GtkTreeSortable* base,
                                          gint* column_id,
                                          GtkSortType* order)
{
	MusicFastModel * self;
	gint _vala_column_id = 0;
	GtkSortType _vala_order = 0;
	GtkSortType _tmp0_;
	gboolean result = FALSE;
	self = (MusicFastModel*) base;
	_vala_column_id = self->priv->sort_column_id;
	_tmp0_ = self->priv->sort_direction;
	_vala_order = _tmp0_;
	result = TRUE;
	if (column_id) {
		*column_id = _vala_column_id;
	}
	if (order) {
		*order = _vala_order;
	}
	return result;
}

static void
music_fast_model_real_set_sort_column_id (GtkTreeSortable* base,
                                          gint column,
                                          GtkSortType order)
{
	MusicFastModel * self;
	self = (MusicFastModel*) base;
	self->priv->sort_column_id = column;
	self->priv->sort_direction = order;
	if (column != -1) {
		g_signal_emit (self, music_fast_model_signals[MUSIC_FAST_MODEL_REORDER_REQUESTED_SIGNAL], 0, column, order);
		gtk_tree_sortable_sort_column_changed ((GtkTreeSortable*) self);
	}
}

/** The following functions are only here to implement TreeSortable **/
static gboolean
music_fast_model_real_has_default_sort_func (GtkTreeSortable* base)
{
	MusicFastModel * self;
	gboolean result = FALSE;
	self = (MusicFastModel*) base;
	result = TRUE;
	return result;
}

static void
music_fast_model_real_set_sort_func (GtkTreeSortable* base,
                                     gint sort_column_id,
                                     GtkTreeIterCompareFunc sort_func,
                                     gpointer sort_func_target,
                                     GDestroyNotify sort_func_target_destroy_notify)
{
	MusicFastModel * self;
	self = (MusicFastModel*) base;
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
	sort_func = NULL;
	sort_func_target = NULL;
	sort_func_target_destroy_notify = NULL;
}

static void
music_fast_model_real_set_default_sort_func (GtkTreeSortable* base,
                                             GtkTreeIterCompareFunc sort_func,
                                             gpointer sort_func_target,
                                             GDestroyNotify sort_func_target_destroy_notify)
{
	MusicFastModel * self;
	self = (MusicFastModel*) base;
	(sort_func_target_destroy_notify == NULL) ? NULL : (sort_func_target_destroy_notify (sort_func_target), NULL);
	sort_func = NULL;
	sort_func_target = NULL;
	sort_func_target_destroy_notify = NULL;
}

GeeList*
music_fast_model_get_columns (MusicFastModel* self)
{
	GeeList* result;
	GeeList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_columns;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
music_fast_model_set_columns (MusicFastModel* self,
                              GeeList* value)
{
	GeeList* old_value;
	g_return_if_fail (self != NULL);
	old_value = music_fast_model_get_columns (self);
	if (old_value != value) {
		GeeList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_columns);
		self->priv->_columns = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, music_fast_model_properties[MUSIC_FAST_MODEL_COLUMNS_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__INT_ENUM (GClosure * closure,
                                        GValue * return_value,
                                        guint n_param_values,
                                        const GValue * param_values,
                                        gpointer invocation_hint,
                                        gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_ENUM) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_ENUM) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_enum (param_values + 2), data2);
}

static GObject *
music_fast_model_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MusicFastModel * self;
	parent_class = G_OBJECT_CLASS (music_fast_model_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_FAST_MODEL, MusicFastModel);
	self->priv->sort_column_id = -2;
	self->priv->sort_direction = GTK_SORT_ASCENDING;
	self->priv->stamp = (gint) g_random_int ();
	return obj;
}

static void
music_fast_model_class_init (MusicFastModelClass * klass,
                             gpointer klass_data)
{
	music_fast_model_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicFastModel_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_music_fast_model_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_music_fast_model_set_property;
	G_OBJECT_CLASS (klass)->constructor = music_fast_model_constructor;
	G_OBJECT_CLASS (klass)->finalize = music_fast_model_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), MUSIC_FAST_MODEL_COLUMNS_PROPERTY, music_fast_model_properties[MUSIC_FAST_MODEL_COLUMNS_PROPERTY] = g_param_spec_object ("columns", "columns", "columns", GEE_TYPE_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	music_fast_model_signals[MUSIC_FAST_MODEL_REORDER_REQUESTED_SIGNAL] = g_signal_new ("reorder-requested", MUSIC_TYPE_FAST_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_ENUM, G_TYPE_NONE, 2, G_TYPE_INT, gtk_sort_type_get_type ());
}

static void
music_fast_model_gtk_tree_model_interface_init (GtkTreeModelIface * iface,
                                                gpointer iface_data)
{
	music_fast_model_gtk_tree_model_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_column_type = (GType (*) (GtkTreeModel*, gint)) music_fast_model_real_get_column_type;
	iface->get_flags = (GtkTreeModelFlags (*) (GtkTreeModel*)) music_fast_model_real_get_flags;
	iface->get_iter = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreePath*)) music_fast_model_real_get_iter;
	iface->get_n_columns = (gint (*) (GtkTreeModel*)) music_fast_model_real_get_n_columns;
	iface->get_path = (GtkTreePath* (*) (GtkTreeModel*, GtkTreeIter*)) music_fast_model_real_get_path;
	iface->get_value = (void (*) (GtkTreeModel*, GtkTreeIter*, gint, GValue*)) music_fast_model_real_get_value;
	iface->iter_children = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) music_fast_model_real_iter_children;
	iface->iter_has_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) music_fast_model_real_iter_has_child;
	iface->iter_n_children = (gint (*) (GtkTreeModel*, GtkTreeIter*)) music_fast_model_real_iter_n_children;
	iface->iter_next = (gboolean (*) (GtkTreeModel*, GtkTreeIter*)) music_fast_model_real_iter_next;
	iface->iter_nth_child = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*, gint)) music_fast_model_real_iter_nth_child;
	iface->iter_parent = (gboolean (*) (GtkTreeModel*, GtkTreeIter*, GtkTreeIter*)) music_fast_model_real_iter_parent;
	iface->ref_node = (void (*) (GtkTreeModel*, GtkTreeIter*)) music_fast_model_real_ref_node;
	iface->unref_node = (void (*) (GtkTreeModel*, GtkTreeIter*)) music_fast_model_real_unref_node;
}

static void
music_fast_model_gtk_tree_sortable_interface_init (GtkTreeSortableIface * iface,
                                                   gpointer iface_data)
{
	music_fast_model_gtk_tree_sortable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_sort_column_id = (gboolean (*) (GtkTreeSortable*, gint*, GtkSortType*)) music_fast_model_real_get_sort_column_id;
	iface->set_sort_column_id = (void (*) (GtkTreeSortable*, gint, GtkSortType)) music_fast_model_real_set_sort_column_id;
	iface->has_default_sort_func = (gboolean (*) (GtkTreeSortable*)) music_fast_model_real_has_default_sort_func;
	iface->set_sort_func = (void (*) (GtkTreeSortable*, gint, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) music_fast_model_real_set_sort_func;
	iface->set_default_sort_func = (void (*) (GtkTreeSortable*, GtkTreeIterCompareFunc, gpointer, GDestroyNotify)) music_fast_model_real_set_default_sort_func;
}

static void
music_fast_model_instance_init (MusicFastModel * self,
                                gpointer klass)
{
	GeeArrayList* _tmp0_;
	self->priv = music_fast_model_get_instance_private (self);
	_tmp0_ = gee_array_list_new (MUSIC_TYPE_MEDIA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	self->priv->rows = _tmp0_;
}

static void
music_fast_model_finalize (GObject * obj)
{
	MusicFastModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_TYPE_FAST_MODEL, MusicFastModel);
	_g_object_unref0 (self->priv->rows);
	_g_object_unref0 (self->priv->_columns);
	G_OBJECT_CLASS (music_fast_model_parent_class)->finalize (obj);
}

static GType
music_fast_model_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicFastModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_fast_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicFastModel), 0, (GInstanceInitFunc) music_fast_model_instance_init, NULL };
	static const GInterfaceInfo gtk_tree_model_info = { (GInterfaceInitFunc) music_fast_model_gtk_tree_model_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gtk_tree_sortable_info = { (GInterfaceInitFunc) music_fast_model_gtk_tree_sortable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType music_fast_model_type_id;
	music_fast_model_type_id = g_type_register_static (G_TYPE_OBJECT, "MusicFastModel", &g_define_type_info, 0);
	g_type_add_interface_static (music_fast_model_type_id, gtk_tree_model_get_type (), &gtk_tree_model_info);
	g_type_add_interface_static (music_fast_model_type_id, gtk_tree_sortable_get_type (), &gtk_tree_sortable_info);
	MusicFastModel_private_offset = g_type_add_instance_private (music_fast_model_type_id, sizeof (MusicFastModelPrivate));
	return music_fast_model_type_id;
}

GType
music_fast_model_get_type (void)
{
	static volatile gsize music_fast_model_type_id__volatile = 0;
	if (g_once_init_enter (&music_fast_model_type_id__volatile)) {
		GType music_fast_model_type_id;
		music_fast_model_type_id = music_fast_model_get_type_once ();
		g_once_init_leave (&music_fast_model_type_id__volatile, music_fast_model_type_id);
	}
	return music_fast_model_type_id__volatile;
}

static void
_vala_music_fast_model_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	MusicFastModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_FAST_MODEL, MusicFastModel);
	switch (property_id) {
		case MUSIC_FAST_MODEL_COLUMNS_PROPERTY:
		g_value_set_object (value, music_fast_model_get_columns (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_music_fast_model_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	MusicFastModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MUSIC_TYPE_FAST_MODEL, MusicFastModel);
	switch (property_id) {
		case MUSIC_FAST_MODEL_COLUMNS_PROPERTY:
		music_fast_model_set_columns (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

