/* iPodDevice.c generated by valac 0.48.17, the Vala compiler
 * generated from iPodDevice.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Music authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Music. This permission is above and beyond the permissions granted
 * by the GPL license by which Music is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <glib.h>
#include <gpod/itdb.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

#define MUSIC_PLUGINS_TYPE_IPOD_DEVICE (music_plugins_ipod_device_get_type ())
#define MUSIC_PLUGINS_IPOD_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_PLUGINS_TYPE_IPOD_DEVICE, MusicPluginsiPodDevice))
#define MUSIC_PLUGINS_IPOD_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_PLUGINS_TYPE_IPOD_DEVICE, MusicPluginsiPodDeviceClass))
#define MUSIC_PLUGINS_IS_IPOD_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_PLUGINS_TYPE_IPOD_DEVICE))
#define MUSIC_PLUGINS_IS_IPOD_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_PLUGINS_TYPE_IPOD_DEVICE))
#define MUSIC_PLUGINS_IPOD_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_PLUGINS_TYPE_IPOD_DEVICE, MusicPluginsiPodDeviceClass))

typedef struct _MusicPluginsiPodDevice MusicPluginsiPodDevice;
typedef struct _MusicPluginsiPodDeviceClass MusicPluginsiPodDeviceClass;
typedef struct _MusicPluginsiPodDevicePrivate MusicPluginsiPodDevicePrivate;

#define MUSIC_PLUGINS_TYPE_IPOD_LIBRARY (music_plugins_ipod_library_get_type ())
#define MUSIC_PLUGINS_IPOD_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MUSIC_PLUGINS_TYPE_IPOD_LIBRARY, MusicPluginsiPodLibrary))
#define MUSIC_PLUGINS_IPOD_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MUSIC_PLUGINS_TYPE_IPOD_LIBRARY, MusicPluginsiPodLibraryClass))
#define MUSIC_PLUGINS_IS_IPOD_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MUSIC_PLUGINS_TYPE_IPOD_LIBRARY))
#define MUSIC_PLUGINS_IS_IPOD_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MUSIC_PLUGINS_TYPE_IPOD_LIBRARY))
#define MUSIC_PLUGINS_IPOD_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MUSIC_PLUGINS_TYPE_IPOD_LIBRARY, MusicPluginsiPodLibraryClass))

typedef struct _MusicPluginsiPodLibrary MusicPluginsiPodLibrary;
typedef struct _MusicPluginsiPodLibraryClass MusicPluginsiPodLibraryClass;
enum  {
	MUSIC_PLUGINS_IPOD_DEVICE_0_PROPERTY,
	MUSIC_PLUGINS_IPOD_DEVICE_NUM_PROPERTIES
};
static GParamSpec* music_plugins_ipod_device_properties[MUSIC_PLUGINS_IPOD_DEVICE_NUM_PROPERTIES];
#define _itdb_free0(var) ((var == NULL) ? NULL : (var = (itdb_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MusicPluginsiPodDevice {
	GObject parent_instance;
	MusicPluginsiPodDevicePrivate * priv;
	GMount* mount;
	gboolean is_supported;
};

struct _MusicPluginsiPodDeviceClass {
	GObjectClass parent_class;
};

struct _MusicPluginsiPodDevicePrivate {
	Itdb_iTunesDB* db;
	GIcon* icon;
	gboolean is_new;
	MusicPluginsiPodLibrary* library;
};

static gint MusicPluginsiPodDevice_private_offset;
static gpointer music_plugins_ipod_device_parent_class = NULL;
static MusicDeviceIface * music_plugins_ipod_device_music_device_parent_iface = NULL;
static GType music_plugins_ipod_device_type_id = 0;

GType music_plugins_ipod_device_register_type (GTypeModule * module);
GType music_plugins_ipod_device_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPluginsiPodDevice, g_object_unref)
GType music_plugins_ipod_library_register_type (GTypeModule * module);
GType music_plugins_ipod_library_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MusicPluginsiPodLibrary, g_object_unref)
MusicPluginsiPodDevice* music_plugins_ipod_device_new (GMount* mount);
MusicPluginsiPodDevice* music_plugins_ipod_device_construct (GType object_type,
                                                             GMount* mount);
static gboolean music_plugins_ipod_device_real_start_initialization (MusicDevice* base);
MusicPluginsiPodLibrary* music_plugins_ipod_library_new (Itdb_iTunesDB* db,
                                                         MusicDevice* device);
MusicPluginsiPodLibrary* music_plugins_ipod_library_construct (GType object_type,
                                                               Itdb_iTunesDB* db,
                                                               MusicDevice* device);
static void music_plugins_ipod_device_real_finish_initialization (MusicDevice* base);
void music_plugins_ipod_library_finish_initialization_async (MusicPluginsiPodLibrary* self,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_);
void music_plugins_ipod_library_finish_initialization_finish (MusicPluginsiPodLibrary* self,
                                                              GAsyncResult* _res_);
static gchar* music_plugins_ipod_device_real_get_empty_device_title (MusicDevice* base);
static gchar* music_plugins_ipod_device_real_get_empty_device_description (MusicDevice* base);
static gchar* music_plugins_ipod_device_real_get_content_type (MusicDevice* base);
static gchar* music_plugins_ipod_device_real_get_display_name (MusicDevice* base);
static void music_plugins_ipod_device_real_set_display_name (MusicDevice* base,
                                                      const gchar* name);
static gchar* music_plugins_ipod_device_real_get_fancy_description (MusicDevice* base);
static void music_plugins_ipod_device_real_set_mount (MusicDevice* base,
                                               GMount* mount);
static GMount* music_plugins_ipod_device_real_get_mount (MusicDevice* base);
static gchar* music_plugins_ipod_device_real_get_uri (MusicDevice* base);
static void music_plugins_ipod_device_real_set_icon (MusicDevice* base,
                                              GIcon* icon);
static GIcon* music_plugins_ipod_device_real_get_icon (MusicDevice* base);
static guint64 music_plugins_ipod_device_real_get_capacity (MusicDevice* base);
static gchar* music_plugins_ipod_device_real_get_fancy_capacity (MusicDevice* base);
static guint64 music_plugins_ipod_device_real_get_used_space (MusicDevice* base);
static guint64 music_plugins_ipod_device_real_get_free_space (MusicDevice* base);
static void music_plugins_ipod_device_real_unmount (MusicDevice* base);
static void music_plugins_ipod_device_real_eject (MusicDevice* base);
static void music_plugins_ipod_device_real_synchronize (MusicDevice* base);
static gboolean music_plugins_ipod_device_real_only_use_custom_view (MusicDevice* base);
static GtkWidget* music_plugins_ipod_device_real_get_custom_view (MusicDevice* base);
static gboolean music_plugins_ipod_device_real_read_only (MusicDevice* base);
static MusicLibrary* music_plugins_ipod_device_real_get_library (MusicDevice* base);
static void music_plugins_ipod_device_finalize (GObject * obj);

static inline gpointer
music_plugins_ipod_device_get_instance_private (MusicPluginsiPodDevice* self)
{
	return G_STRUCT_MEMBER_P (self, MusicPluginsiPodDevice_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

MusicPluginsiPodDevice*
music_plugins_ipod_device_construct (GType object_type,
                                     GMount* mount)
{
	MusicPluginsiPodDevice * self = NULL;
	GMount* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_ = NULL;
	GThemedIcon* _tmp6_;
	g_return_val_if_fail (mount != NULL, NULL);
	self = (MusicPluginsiPodDevice*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (mount);
	_g_object_unref0 (self->mount);
	self->mount = _tmp0_;
	_tmp1_ = g_mount_get_default_location (mount);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_get_parse_name (_tmp2_);
	_tmp4_ = _tmp3_;
	self->priv->is_new = g_str_has_prefix (_tmp4_, "afc://");
	_g_free0 (_tmp4_);
	_g_object_unref0 (_tmp2_);
	if (self->priv->is_new) {
		_tmp5_ = "phone";
	} else {
		_tmp5_ = "multimedia-player";
	}
	_tmp6_ = (GThemedIcon*) g_themed_icon_new (_tmp5_);
	_g_object_unref0 (self->priv->icon);
	self->priv->icon = (GIcon*) _tmp6_;
	return self;
}

MusicPluginsiPodDevice*
music_plugins_ipod_device_new (GMount* mount)
{
	return music_plugins_ipod_device_construct (MUSIC_PLUGINS_TYPE_IPOD_DEVICE, mount);
}

static gboolean
music_plugins_ipod_device_real_start_initialization (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	self = (MusicPluginsiPodDevice*) base;
	{
		Itdb_iTunesDB* _tmp0_ = NULL;
		GMount* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		Itdb_iTunesDB* _tmp6_;
		Itdb_iTunesDB* _tmp7_;
		Itdb_iTunesDB* _tmp8_;
		gboolean _tmp9_ = FALSE;
		Itdb_iTunesDB* _tmp10_;
		Itdb_Device* _tmp11_;
		Itdb_IpodInfo* _tmp12_;
		Itdb_IpodModel _tmp13_;
		Itdb_iTunesDB* _tmp18_;
		MusicPluginsiPodLibrary* _tmp19_;
		MusicLibrariesManager* _tmp20_;
		MusicPluginsiPodLibrary* _tmp21_;
		_tmp1_ = self->mount;
		_tmp2_ = g_mount_get_default_location (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_file_get_path (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = itdb_parse (_tmp5_, &_inner_error0_);
		_tmp7_ = _tmp6_;
		_g_free0 (_tmp5_);
		_g_object_unref0 (_tmp3_);
		_tmp0_ = _tmp7_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp8_ = _tmp0_;
		_tmp0_ = NULL;
		_itdb_free0 (self->priv->db);
		self->priv->db = _tmp8_;
		_tmp10_ = self->priv->db;
		_tmp11_ = _tmp10_->device;
		_tmp12_ = itdb_device_get_ipod_info (_tmp11_);
		_tmp13_ = _tmp12_->ipod_model;
		if (_tmp13_ == ITDB_IPOD_MODEL_INVALID) {
			_tmp9_ = TRUE;
		} else {
			Itdb_iTunesDB* _tmp14_;
			Itdb_Device* _tmp15_;
			Itdb_IpodInfo* _tmp16_;
			Itdb_IpodModel _tmp17_;
			_tmp14_ = self->priv->db;
			_tmp15_ = _tmp14_->device;
			_tmp16_ = itdb_device_get_ipod_info (_tmp15_);
			_tmp17_ = _tmp16_->ipod_model;
			_tmp9_ = _tmp17_ == ITDB_IPOD_MODEL_UNKNOWN;
		}
		if (_tmp9_) {
			self->is_supported = FALSE;
		}
		_tmp18_ = self->priv->db;
		_tmp19_ = music_plugins_ipod_library_new (_tmp18_, (MusicDevice*) self);
		_g_object_unref0 (self->priv->library);
		self->priv->library = _tmp19_;
		_tmp20_ = music_libraries_manager;
		_tmp21_ = self->priv->library;
		music_libraries_manager_add_library (_tmp20_, (MusicLibrary*) _tmp21_);
		_itdb_free0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp22_;
		gchar* _tmp23_;
		GError* _tmp24_;
		const gchar* _tmp25_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp22_ = music_device_get_uri ((MusicDevice*) self);
		_tmp23_ = _tmp22_;
		_tmp24_ = err;
		_tmp25_ = _tmp24_->message;
		g_critical ("iPodDevice.vala:56: Error parsing db at %s: %s\n", _tmp23_, _tmp25_);
		_g_free0 (_tmp23_);
		result = FALSE;
		_g_error_free0 (err);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp26_ = FALSE;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp26_;
	}
	result = TRUE;
	return result;
}

static void
music_plugins_ipod_device_real_finish_initialization (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	MusicPluginsiPodLibrary* _tmp0_;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = self->priv->library;
	music_plugins_ipod_library_finish_initialization_async (_tmp0_, NULL, NULL);
}

static gchar*
music_plugins_ipod_device_real_get_empty_device_title (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = g_strdup (_ ("Empty device!"));
	result = _tmp0_;
	return result;
}

static gchar*
music_plugins_ipod_device_real_get_empty_device_description (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = g_strdup (_ ("This device does not contain any music."));
	result = _tmp0_;
	return result;
}

static gchar*
music_plugins_ipod_device_real_get_content_type (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gchar* result = NULL;
	self = (MusicPluginsiPodDevice*) base;
	if (self->priv->is_new) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup ("ipod-new");
		result = _tmp0_;
		return result;
	} else {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("ipod-old");
		result = _tmp1_;
		return result;
	}
}

static gchar*
music_plugins_ipod_device_real_get_display_name (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	Itdb_iTunesDB* _tmp0_;
	Itdb_Playlist* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = self->priv->db;
	_tmp1_ = itdb_playlist_mpl (_tmp0_);
	_tmp2_ = _tmp1_->name;
	_tmp3_ = g_strdup (_tmp2_);
	result = _tmp3_;
	return result;
}

static void
music_plugins_ipod_device_real_set_display_name (MusicDevice* base,
                                                 const gchar* name)
{
	MusicPluginsiPodDevice * self;
	Itdb_iTunesDB* _tmp0_;
	Itdb_Playlist* _tmp1_;
	gchar* _tmp2_;
	MusicDeviceManager* _tmp10_;
	MusicDeviceManager* _tmp11_;
	GError* _inner_error0_ = NULL;
	self = (MusicPluginsiPodDevice*) base;
	g_return_if_fail (name != NULL);
	_tmp0_ = self->priv->db;
	_tmp1_ = itdb_playlist_mpl (_tmp0_);
	_tmp2_ = g_strdup (name);
	_g_free0 (_tmp1_->name);
	_tmp1_->name = _tmp2_;
	{
		GMount* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
		_tmp3_ = self->mount;
		_tmp4_ = g_mount_get_default_location (_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = g_file_set_display_name (_tmp5_, name, NULL, &_inner_error0_);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp7_);
		_g_object_unref0 (_tmp5_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = err;
		_tmp9_ = _tmp8_->message;
		g_critical ("iPodDevice.vala:91: Could not set iPod Mount Display Name: %s\n", _tmp9_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp10_ = music_device_manager_get_default ();
	_tmp11_ = _tmp10_;
	g_signal_emit_by_name (_tmp11_, "device-name-changed", (MusicDevice*) self);
	_g_object_unref0 (_tmp11_);
}

static gchar*
music_plugins_ipod_device_real_get_fancy_description (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	Itdb_IpodGeneration enum_gen = 0;
	Itdb_iTunesDB* _tmp0_;
	Itdb_Device* _tmp1_;
	Itdb_IpodInfo* _tmp2_;
	Itdb_IpodGeneration _tmp3_;
	Itdb_IpodGeneration _tmp4_;
	gchar* result = NULL;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = self->priv->db;
	_tmp1_ = _tmp0_->device;
	_tmp2_ = itdb_device_get_ipod_info (_tmp1_);
	_tmp3_ = _tmp2_->ipod_generation;
	enum_gen = _tmp3_;
	_tmp4_ = enum_gen;
	switch (_tmp4_) {
		case ITDB_IPOD_GENERATION_FIRST:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup ("iPod 1G");
			result = _tmp5_;
			return result;
		}
		case ITDB_IPOD_GENERATION_SECOND:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup ("iPod 2G");
			result = _tmp6_;
			return result;
		}
		case ITDB_IPOD_GENERATION_THIRD:
		{
			gchar* _tmp7_;
			_tmp7_ = g_strdup ("iPod 3G");
			result = _tmp7_;
			return result;
		}
		case ITDB_IPOD_GENERATION_FOURTH:
		{
			gchar* _tmp8_;
			_tmp8_ = g_strdup ("iPod 4G");
			result = _tmp8_;
			return result;
		}
		case ITDB_IPOD_GENERATION_PHOTO:
		{
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("iPod photo");
			result = _tmp9_;
			return result;
		}
		case ITDB_IPOD_GENERATION_VIDEO_1:
		{
			gchar* _tmp10_;
			_tmp10_ = g_strdup ("iPod video");
			result = _tmp10_;
			return result;
		}
		case ITDB_IPOD_GENERATION_VIDEO_2:
		{
			gchar* _tmp11_;
			_tmp11_ = g_strdup ("iPod video 2G");
			result = _tmp11_;
			return result;
		}
		case ITDB_IPOD_GENERATION_MOBILE:
		{
			gchar* _tmp12_;
			_tmp12_ = g_strdup ("iPod mobile");
			result = _tmp12_;
			return result;
		}
		case ITDB_IPOD_GENERATION_MINI_1:
		{
			gchar* _tmp13_;
			_tmp13_ = g_strdup ("iPod mini");
			result = _tmp13_;
			return result;
		}
		case ITDB_IPOD_GENERATION_MINI_2:
		{
			gchar* _tmp14_;
			_tmp14_ = g_strdup ("iPod mini 2G");
			result = _tmp14_;
			return result;
		}
		case ITDB_IPOD_GENERATION_SHUFFLE_1:
		{
			gchar* _tmp15_;
			_tmp15_ = g_strdup ("iPod shuffle");
			result = _tmp15_;
			return result;
		}
		case ITDB_IPOD_GENERATION_SHUFFLE_2:
		{
			gchar* _tmp16_;
			_tmp16_ = g_strdup ("iPod shuffle 2G");
			result = _tmp16_;
			return result;
		}
		case ITDB_IPOD_GENERATION_SHUFFLE_3:
		{
			gchar* _tmp17_;
			_tmp17_ = g_strdup ("iPod shuffle 3G");
			result = _tmp17_;
			return result;
		}
		case ITDB_IPOD_GENERATION_SHUFFLE_4:
		{
			gchar* _tmp18_;
			_tmp18_ = g_strdup ("iPod shuffle 4G");
			result = _tmp18_;
			return result;
		}
		case ITDB_IPOD_GENERATION_NANO_1:
		{
			gchar* _tmp19_;
			_tmp19_ = g_strdup ("iPod nano");
			result = _tmp19_;
			return result;
		}
		case ITDB_IPOD_GENERATION_NANO_2:
		{
			gchar* _tmp20_;
			_tmp20_ = g_strdup ("iPod nano 2G");
			result = _tmp20_;
			return result;
		}
		case ITDB_IPOD_GENERATION_NANO_3:
		{
			gchar* _tmp21_;
			_tmp21_ = g_strdup ("iPod nano 3G");
			result = _tmp21_;
			return result;
		}
		case ITDB_IPOD_GENERATION_NANO_4:
		{
			gchar* _tmp22_;
			_tmp22_ = g_strdup ("iPod nano 4G");
			result = _tmp22_;
			return result;
		}
		case ITDB_IPOD_GENERATION_NANO_5:
		{
			gchar* _tmp23_;
			_tmp23_ = g_strdup ("iPod nano 5G");
			result = _tmp23_;
			return result;
		}
		case ITDB_IPOD_GENERATION_NANO_6:
		{
			gchar* _tmp24_;
			_tmp24_ = g_strdup ("iPod nano 6G");
			result = _tmp24_;
			return result;
		}
		case ITDB_IPOD_GENERATION_CLASSIC_1:
		{
			gchar* _tmp25_;
			_tmp25_ = g_strdup ("iPod classic");
			result = _tmp25_;
			return result;
		}
		case ITDB_IPOD_GENERATION_CLASSIC_2:
		{
			gchar* _tmp26_;
			_tmp26_ = g_strdup ("iPod classic 2G");
			result = _tmp26_;
			return result;
		}
		case ITDB_IPOD_GENERATION_CLASSIC_3:
		{
			gchar* _tmp27_;
			_tmp27_ = g_strdup ("iPod classic 3G");
			result = _tmp27_;
			return result;
		}
		case ITDB_IPOD_GENERATION_TOUCH_1:
		{
			gchar* _tmp28_;
			_tmp28_ = g_strdup ("iPod touch 1G");
			result = _tmp28_;
			return result;
		}
		case ITDB_IPOD_GENERATION_TOUCH_2:
		{
			gchar* _tmp29_;
			_tmp29_ = g_strdup ("iPod touch 2G");
			result = _tmp29_;
			return result;
		}
		case ITDB_IPOD_GENERATION_TOUCH_3:
		{
			gchar* _tmp30_;
			_tmp30_ = g_strdup ("iPod touch 3G");
			result = _tmp30_;
			return result;
		}
		case ITDB_IPOD_GENERATION_TOUCH_4:
		{
			gchar* _tmp31_;
			_tmp31_ = g_strdup ("iPod touch 4G");
			result = _tmp31_;
			return result;
		}
		case ITDB_IPOD_GENERATION_IPHONE_1:
		{
			gchar* _tmp32_;
			_tmp32_ = g_strdup ("iPhone");
			result = _tmp32_;
			return result;
		}
		case ITDB_IPOD_GENERATION_IPHONE_2:
		{
			gchar* _tmp33_;
			_tmp33_ = g_strdup ("iPhone 2G");
			result = _tmp33_;
			return result;
		}
		case ITDB_IPOD_GENERATION_IPHONE_3:
		{
			gchar* _tmp34_;
			_tmp34_ = g_strdup ("iPhone 3G(S)");
			result = _tmp34_;
			return result;
		}
		case ITDB_IPOD_GENERATION_IPHONE_4:
		{
			gchar* _tmp35_;
			_tmp35_ = g_strdup ("iPhone 4(S)");
			result = _tmp35_;
			return result;
		}
		case ITDB_IPOD_GENERATION_IPAD_1:
		{
			gchar* _tmp36_;
			_tmp36_ = g_strdup ("iPad");
			result = _tmp36_;
			return result;
		}
		default:
		{
			gchar* _tmp37_;
			_tmp37_ = g_strdup ("");
			result = _tmp37_;
			return result;
		}
	}
}

static void
music_plugins_ipod_device_real_set_mount (MusicDevice* base,
                                          GMount* mount)
{
	MusicPluginsiPodDevice * self;
	GMount* _tmp0_;
	self = (MusicPluginsiPodDevice*) base;
	g_return_if_fail (mount != NULL);
	_tmp0_ = _g_object_ref0 (mount);
	_g_object_unref0 (self->mount);
	self->mount = _tmp0_;
}

static GMount*
music_plugins_ipod_device_real_get_mount (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GMount* _tmp0_;
	GMount* _tmp1_;
	GMount* result = NULL;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = self->mount;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static gchar*
music_plugins_ipod_device_real_get_uri (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GMount* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result = NULL;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = self->mount;
	_tmp1_ = g_mount_get_default_location (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_get_uri (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp2_);
	result = _tmp4_;
	return result;
}

static void
music_plugins_ipod_device_real_set_icon (MusicDevice* base,
                                         GIcon* icon)
{
	MusicPluginsiPodDevice * self;
	GIcon* _tmp0_;
	self = (MusicPluginsiPodDevice*) base;
	g_return_if_fail (icon != NULL);
	_tmp0_ = _g_object_ref0 (icon);
	_g_object_unref0 (self->priv->icon);
	self->priv->icon = _tmp0_;
}

static GIcon*
music_plugins_ipod_device_real_get_icon (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GIcon* _tmp0_;
	GIcon* _tmp1_;
	GIcon* result = NULL;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = self->priv->icon;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	result = _tmp1_;
	return result;
}

static guint64
music_plugins_ipod_device_real_get_capacity (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	guint64 rv = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
	self = (MusicPluginsiPodDevice*) base;
	rv = (guint64) 0;
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
		_tmp0_ = music_device_get_uri ((MusicDevice*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_file_new_for_uri (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_g_free0 (_tmp1_);
		file_info = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE);
		_g_object_unref0 (file_info);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = err;
		_tmp7_ = _tmp6_->message;
		g_critical ("iPodDevice.vala:195: Error calculating capacity of iPod: %s\n", _tmp7_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		guint64 _tmp8_ = 0ULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp8_;
	}
	result = rv;
	return result;
}

static gchar*
music_plugins_ipod_device_real_get_fancy_capacity (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = g_format_size_full (music_device_get_capacity ((MusicDevice*) self), G_FORMAT_SIZE_DEFAULT);
	result = _tmp0_;
	return result;
}

static guint64
music_plugins_ipod_device_real_get_used_space (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	guint64 result = 0ULL;
	self = (MusicPluginsiPodDevice*) base;
	result = music_device_get_capacity ((MusicDevice*) self) - music_device_get_free_space ((MusicDevice*) self);
	return result;
}

static guint64
music_plugins_ipod_device_real_get_free_space (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	guint64 rv = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
	self = (MusicPluginsiPodDevice*) base;
	rv = (guint64) 0;
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
		_tmp0_ = music_device_get_uri ((MusicDevice*) self);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_file_new_for_uri (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
		_tmp5_ = _tmp4_;
		_g_object_unref0 (_tmp3_);
		_g_free0 (_tmp1_);
		file_info = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
		_g_object_unref0 (file_info);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = err;
		_tmp7_ = _tmp6_->message;
		g_critical ("iPodDevice.vala:215: Error calculating free space on iPod: %s\n", _tmp7_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		guint64 _tmp8_ = 0ULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp8_;
	}
	result = rv;
	return result;
}

static void
music_plugins_ipod_device_real_unmount (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GMount* _tmp0_;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = self->mount;
	g_mount_unmount_with_operation (_tmp0_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
}

static void
music_plugins_ipod_device_real_eject (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GMount* _tmp0_;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = self->mount;
	if (g_mount_can_eject (_tmp0_)) {
		GMount* _tmp1_;
		GVolume* _tmp2_;
		GVolume* _tmp3_;
		GDrive* _tmp4_;
		GDrive* _tmp5_;
		_tmp1_ = self->mount;
		_tmp2_ = g_mount_get_volume (_tmp1_);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_volume_get_drive (_tmp3_);
		_tmp5_ = _tmp4_;
		g_drive_eject_with_operation (_tmp5_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
		_g_object_unref0 (_tmp5_);
		_g_object_unref0 (_tmp3_);
	}
}

static void
music_plugins_ipod_device_real_synchronize (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	self = (MusicPluginsiPodDevice*) base;
}

static gboolean
music_plugins_ipod_device_real_only_use_custom_view (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gboolean result = FALSE;
	self = (MusicPluginsiPodDevice*) base;
	result = FALSE;
	return result;
}

static GtkWidget*
music_plugins_ipod_device_real_get_custom_view (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	GtkWidget* result = NULL;
	self = (MusicPluginsiPodDevice*) base;
	result = NULL;
	return result;
}

static gboolean
music_plugins_ipod_device_real_read_only (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	gboolean result = FALSE;
	self = (MusicPluginsiPodDevice*) base;
	result = FALSE;
	return result;
}

static MusicLibrary*
music_plugins_ipod_device_real_get_library (MusicDevice* base)
{
	MusicPluginsiPodDevice * self;
	MusicPluginsiPodLibrary* _tmp0_;
	MusicLibrary* _tmp1_;
	MusicLibrary* result = NULL;
	self = (MusicPluginsiPodDevice*) base;
	_tmp0_ = self->priv->library;
	_tmp1_ = _g_object_ref0 ((MusicLibrary*) _tmp0_);
	result = _tmp1_;
	return result;
}

static void
music_plugins_ipod_device_class_init (MusicPluginsiPodDeviceClass * klass,
                                      gpointer klass_data)
{
	music_plugins_ipod_device_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MusicPluginsiPodDevice_private_offset);
	G_OBJECT_CLASS (klass)->finalize = music_plugins_ipod_device_finalize;
}

static void
music_plugins_ipod_device_music_device_interface_init (MusicDeviceIface * iface,
                                                       gpointer iface_data)
{
	music_plugins_ipod_device_music_device_parent_iface = g_type_interface_peek_parent (iface);
	iface->start_initialization = (gboolean (*) (MusicDevice*)) music_plugins_ipod_device_real_start_initialization;
	iface->finish_initialization = (void (*) (MusicDevice*)) music_plugins_ipod_device_real_finish_initialization;
	iface->get_empty_device_title = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_empty_device_title;
	iface->get_empty_device_description = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_empty_device_description;
	iface->get_content_type = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_content_type;
	iface->get_display_name = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_display_name;
	iface->set_display_name = (void (*) (MusicDevice*, const gchar*)) music_plugins_ipod_device_real_set_display_name;
	iface->get_fancy_description = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_fancy_description;
	iface->set_mount = (void (*) (MusicDevice*, GMount*)) music_plugins_ipod_device_real_set_mount;
	iface->get_mount = (GMount* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_mount;
	iface->get_uri = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_uri;
	iface->set_icon = (void (*) (MusicDevice*, GIcon*)) music_plugins_ipod_device_real_set_icon;
	iface->get_icon = (GIcon* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_icon;
	iface->get_capacity = (guint64 (*) (MusicDevice*)) music_plugins_ipod_device_real_get_capacity;
	iface->get_fancy_capacity = (gchar* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_fancy_capacity;
	iface->get_used_space = (guint64 (*) (MusicDevice*)) music_plugins_ipod_device_real_get_used_space;
	iface->get_free_space = (guint64 (*) (MusicDevice*)) music_plugins_ipod_device_real_get_free_space;
	iface->unmount = (void (*) (MusicDevice*)) music_plugins_ipod_device_real_unmount;
	iface->eject = (void (*) (MusicDevice*)) music_plugins_ipod_device_real_eject;
	iface->synchronize = (void (*) (MusicDevice*)) music_plugins_ipod_device_real_synchronize;
	iface->only_use_custom_view = (gboolean (*) (MusicDevice*)) music_plugins_ipod_device_real_only_use_custom_view;
	iface->get_custom_view = (GtkWidget* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_custom_view;
	iface->read_only = (gboolean (*) (MusicDevice*)) music_plugins_ipod_device_real_read_only;
	iface->get_library = (MusicLibrary* (*) (MusicDevice*)) music_plugins_ipod_device_real_get_library;
}

static void
music_plugins_ipod_device_instance_init (MusicPluginsiPodDevice * self,
                                         gpointer klass)
{
	self->priv = music_plugins_ipod_device_get_instance_private (self);
	self->is_supported = TRUE;
	self->priv->is_new = FALSE;
}

static void
music_plugins_ipod_device_finalize (GObject * obj)
{
	MusicPluginsiPodDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MUSIC_PLUGINS_TYPE_IPOD_DEVICE, MusicPluginsiPodDevice);
	_itdb_free0 (self->priv->db);
	_g_object_unref0 (self->mount);
	_g_object_unref0 (self->priv->icon);
	_g_object_unref0 (self->priv->library);
	G_OBJECT_CLASS (music_plugins_ipod_device_parent_class)->finalize (obj);
}

GType
music_plugins_ipod_device_get_type (void)
{
	return music_plugins_ipod_device_type_id;
}

GType
music_plugins_ipod_device_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (MusicPluginsiPodDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) music_plugins_ipod_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MusicPluginsiPodDevice), 0, (GInstanceInitFunc) music_plugins_ipod_device_instance_init, NULL };
	static const GInterfaceInfo music_device_info = { (GInterfaceInitFunc) music_plugins_ipod_device_music_device_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	music_plugins_ipod_device_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "MusicPluginsiPodDevice", &g_define_type_info, 0);
	g_type_module_add_interface (module, music_plugins_ipod_device_type_id, MUSIC_TYPE_DEVICE, &music_device_info);
	MusicPluginsiPodDevice_private_offset = sizeof (MusicPluginsiPodDevicePrivate);
	return music_plugins_ipod_device_type_id;
}

